/*
 * Copyright (c) 2005-2012, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#include "stdafx.h"
#include "ArcEntryInfo.h"
#include "../Utilities/FileOperation.h"

ARCHIVE_ENTRY_INFO_TREE* ARCHIVE_ENTRY_INFO_TREE::GetChild(size_t idx)const
{
	if(0<=idx && idx<GetNumChildren()){
		return childrenArray[idx];
	}else return NULL;
}

ARCHIVE_ENTRY_INFO_TREE* ARCHIVE_ENTRY_INFO_TREE::GetChild(LPCTSTR lpName)const
{
	CString strTmp=lpName;
	strTmp.MakeLower();
	DICT::const_iterator ite=childrenDict.find((LPCTSTR)strTmp);
	if(ite!=childrenDict.end()){
		return (*ite).second;
	}else return NULL;
}

void ARCHIVE_ENTRY_INFO_TREE::EnumFiles(std::list<CString> &rFileList)const
{
	if(bDir){
		size_t size=childrenArray.size();
		for(size_t i=0;i<size;i++){
			childrenArray[i]->EnumFiles(rFileList);
		}
	}
	if(!strFullPath.IsEmpty()){
		rFileList.push_back(strFullPath);
	}
}


//---------------
void ArcEntryInfoTree_GetNodePathRelative(const ARCHIVE_ENTRY_INFO_TREE* lpNode,const ARCHIVE_ENTRY_INFO_TREE* lpBase,CString &strPath)
{
	//Ŗʓ|ȂƂĂ̂́A
	//lpBasetpXĂȂ(=LhaForgezIɍotH_)Ƃ邩B
	strPath=_T("");

	for(; lpNode->lpParent && lpBase!=lpNode ;lpNode=lpNode->lpParent){
		CString strTmp=lpNode->strTitle;
		strTmp.Replace(_T('/'),_T('\\'));

		CPath strBuffer=strTmp;
		if(-1!=strTmp.Find(_T('\\'))){
			//fBNgm[h̖OɃpX؂蕶̂́AKw\𖳎ꗗ̎̂݁B
			//̂Ƃ́ApX؂S΂KvB
			strBuffer.StripPath();	//ԍŌ̕cāApXJbg
			strBuffer.RemoveBackslash();	//pX؂蕶U폜
		}
		if(lpNode->bDir){
			strBuffer.AddBackslash();
		}
		strPath.Insert(0,strBuffer);
	}
	// o̓pX̏C
	UtilModifyPath(strPath);
}

