/*
 * Copyright (c) 2005-2012, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#pragma once
#include "../resource.h"
#include "ArcEntryInfo.h"
#include "../ConfigCode/ConfigManager.h"

typedef	HGLOBAL	HARC;
#ifndef FNAME_MAX32
#define FNAME_MAX32		512
#endif
typedef struct {
	DWORD 			dwOriginalSize;		/* t@C̃TCY */
 	DWORD 			dwCompressedSize;	/* k̃TCY */
	DWORD			dwCRC;				/* i[t@C̃`FbNT */
	UINT			uFlag;				/*  */
	UINT			uOSType;			/* ɍ쐬Ɏgꂽnr */
	WORD			wRatio;				/* k */
	WORD			wDate;				/* i[t@C̓t(DOS `) */
	WORD 			wTime;				/* i[t@C̎(V) */
	char			szFileName[FNAME_MAX32 + 1];	/* ɖ */
	char			dummy1[3];
	char			szAttribute[8];		/* i[t@C̑(ɌŗL) */
	char			szMode[8];			/* i[t@C̊i[[h(V) */
}	INDIVIDUALINFO, *LPINDIVIDUALINFO;

typedef int   (WINAPI *COMMON_ARCHIVER_HANDLER)(const HWND,LPCSTR,LPSTR,const DWORD);
typedef WORD  (WINAPI *COMMON_ARCHIVER_GETVERSION)(VOID);	//GetVersion/GetSubVersion
typedef BOOL  (WINAPI *COMMON_ARCHIVER_CHECKARCHIVE)(LPCSTR,const int);

typedef int	  (WINAPI *COMMON_ARCHIVER_GETFILENAME)(HARC,LPCSTR,int);
typedef BOOL  (WINAPI *COMMON_ARCHIVER_QUERYFUNCTIONLIST)(const int);
typedef HARC  (WINAPI *COMMON_ARCHIVER_OPENARCHIVE)(const HWND,LPCSTR,const DWORD);
typedef HARC  (WINAPI *COMMON_ARCHIVER_OPENARCHIVE2)(const HWND,LPCSTR,const DWORD,LPCSTR);
typedef int   (WINAPI *COMMON_ARCHIVER_CLOSEARCHIVE)(HARC);
typedef int   (WINAPI *COMMON_ARCHIVER_FINDFIRST)(HARC,LPCSTR,LPINDIVIDUALINFO);
typedef int   (WINAPI *COMMON_ARCHIVER_FINDNEXT)(HARC,LPINDIVIDUALINFO);
typedef int   (WINAPI *COMMON_ARCHIVER_GETATTRIBUTE)(HARC);
typedef BOOL  (WINAPI *COMMON_ARCHIVER_GETORIGINALSIZEEX)(HARC,LARGE_INTEGER*);
typedef DWORD (WINAPI *COMMON_ARCHIVER_GETWRITETIME)(HARC);
typedef BOOL  (WINAPI *COMMON_ARCHIVER_GETWRITETIMEEX)(HARC,LPFILETIME);
typedef int	  (WINAPI *COMMON_ARCHIVER_GETFILECOUNT)(LPCSTR);
typedef int   (WINAPI *COMMON_ARCHIVER_GETMETHOD)(HARC,LPSTR,const int);

typedef BOOL   (WINAPI *COMMON_ARCHIVER_SETUNICODEMODE)(BOOL);


#define	CHECKARCHIVE_RAPID		0
#define	CHECKARCHIVE_BASIC		1
#define	CHECKARCHIVE_FULLCRC	2

#define CHECKARCHIVE_RECOVERY	4   /* jwb_ǂݔ΂ď */
#define CHECKARCHIVE_SFX		8	/* SFX ǂԂ */
#define CHECKARCHIVE_ALL		16	/* t@C̍Ō܂Ō */
#define CHECKARCHIVE_ENDDATA	32	/* ɂ̗]f[^ */

#define	CHECKARCHIVE_NOT_ASK_PASSWORD	64

#define ERROR_PASSWORD_FILE		0x800A


enum PARAMETER_TYPE;

enum LOAD_DLL_LEVEL{
	LOAD_DLL_STANDARD	=0x00000001L,					//ʏ
	LOAD_DLL_MINIMUM	=0x00000002L,					//OpenArchive*gȂDLLp
	LOAD_DLL_SIMPLE_INSPECTION	=0x00000004L,				//%Prefix%(),OpenArchive(),FindFile*()ȊOgȂDLL(BGA32.DLL)p
//	LOAD_DLL_STANDARD_WITHOUT_GETATTRIBUTE=0x00000004L,	//GetAttributegȂDLLp̒ʏ
};

enum LOAD_RESULT{
	LOAD_RESULT_OK,			//DLL͐Ƀ[hꂽ
	LOAD_RESULT_NOT_FOUND,	//DLLȂ
	LOAD_RESULT_INVALID,	//sDLL
	LOAD_RESULT_TOO_OLD		//DLL̓T|[gĂo[WÂ
};

const int LOG_BUFFER_SIZE=512*1024;	//512KB

enum COMPRESS_MODE{
	COMPRESS_SFX				=	0x00000001L,
	COMPRESS_PASSWORD			=	0x00000002L,
	COMPRESS_PUBLIC_PASSWORD	=	0x00000004L,
	COMPRESS_SPLIT				=	0x00000008L,
};

//k`p[^
enum PARAMETER_TYPE{
	PARAMETER_UNDEFINED,
	PARAMETER_LZH,
	PARAMETER_ZIP,
	PARAMETER_CAB,
	PARAMETER_7Z,
	PARAMETER_JACK,
//	PARAMETER_BH,
	PARAMETER_HKI,
	PARAMETER_YZ1,
//	PARAMETER_YZ2,
	PARAMETER_BZA,
	PARAMETER_GZA,
	PARAMETER_ISH,
	PARAMETER_UUE,

	PARAMETER_TAR,
	PARAMETER_BZ2,
	PARAMETER_GZ,
	PARAMETER_TAR_GZ,	//tar.gz,tgz
	PARAMETER_TAR_BZ2,	//tar.bz2,tbz
	PARAMETER_XZ,
	PARAMETER_TAR_XZ,	//tar.xz,txz
	PARAMETER_LZMA,
	PARAMETER_TAR_LZMA,	//tar.lzma

	PARAMETER_B2E,	//B2E͓ʈ

	ENUM_COUNT_AND_LASTITEM(PARAMETER),
};

//Compress/Extract/TestArchive̖߂l
enum ARCRESULT{
	//---𓀌n
	EXTRACT_OK,//I
	EXTRACT_NG,//ُI
	EXTRACT_CANCELED,//LZ
	EXTRACT_NOTARCHIVE,//kt@Cł͂Ȃ
	EXTRACT_INFECTED,//EBX̉\

	//---n
	TEST_OK,	//t@C͐
	TEST_NG,	//t@CɈُ킠
	TEST_NOTIMPL,//͎ĂȂ
	TEST_NOTARCHIVE,//kt@Cł͂Ȃ
	TEST_INFECTED,//EBX̉\
	TEST_ERROR,	//G[(DLL[hĂȂ̂ɌĂяoꂽA)
};

struct ARCLOG{	//A[JCǔʂi[
	virtual ~ARCLOG(){}
	CString strFile;	//A[JCũtpX
	CString strMsg;		//O
	ARCRESULT Result;	//
};


enum LOGVIEW{
	LOGVIEW_ON_ERROR,
	LOGVIEW_ALWAYS,
	LOGVIEW_NEVER,

	ENUM_COUNT_AND_LASTITEM(LOGVIEW),
};
enum LOSTDIR{
	LOSTDIR_ASK_TO_CREATE,
	LOSTDIR_FORCE_CREATE,
	LOSTDIR_ERROR,

	ENUM_COUNT_AND_LASTITEM(LOSTDIR),
};
enum OUTPUT_TO{
	OUTPUT_TO_DESKTOP,
	OUTPUT_TO_SAME_DIR,
	OUTPUT_TO_SPECIFIC_DIR,
	OUTPUT_TO_ALWAYS_ASK_WHERE,

	ENUM_COUNT_AND_LASTITEM(OUTPUT_TO),
};
enum CREATE_OUTPUT_DIR{
	CREATE_OUTPUT_DIR_ALWAYS,
	CREATE_OUTPUT_DIR_SINGLE,
	CREATE_OUTPUT_DIR_NEVER,

	ENUM_COUNT_AND_LASTITEM(CREATE_OUTPUT_DIR)
};

struct CConfigExtract;
//A[JCoDLLbvpNX̃x[X
class CArchiverDLL{
protected:
	//DLLŗL̃f[^
	DWORD			m_dwInspectMode;		//OpenArchivẽ[h
	CString			m_strDllName;			//DLL
	CStringA		m_AstrPrefix;				//֐vtBbNX
	CStringA		m_AstrFindParam;			//InspectArchiveFileNext()̈
	LOAD_DLL_LEVEL	m_LoadLevel;			//LoadDLLŗv֐̃x
	WORD			m_nRequiredVersion;	//LhaForgeT|[gDLL̍Œo[W
	WORD			m_nRequiredSubVersion;	//LhaForgeT|[gDLL̍ŒTuo[W

	//---------
	//ɓ̏ԂL^邽߂̕ϐ
	HARC m_hInspectArchive;
	bool m_bInspectFirstTime;
	INDIVIDUALINFO m_IndividualInfo;

	//---------
	HINSTANCE	m_hInstDLL;			//DLLCX^X
	COMMON_ARCHIVER_HANDLER			ArchiveHandler;	//Un???֐
	COMMON_ARCHIVER_GETVERSION		ArchiverGetVersion;
	COMMON_ARCHIVER_GETVERSION		ArchiverGetSubVersion;
	COMMON_ARCHIVER_CHECKARCHIVE	ArchiverCheckArchive;
	COMMON_ARCHIVER_GETFILECOUNT	ArchiverGetFileCount;
	//ȉ̊֐͓dtH_肨ъ댯A[JCuȂǃA[JCuɎg
	COMMON_ARCHIVER_QUERYFUNCTIONLIST		ArchiverQueryFunctionList;
	COMMON_ARCHIVER_GETFILENAME				ArchiverGetFileName;
	COMMON_ARCHIVER_OPENARCHIVE				ArchiverOpenArchive;
	COMMON_ARCHIVER_CLOSEARCHIVE			ArchiverCloseArchive;
	COMMON_ARCHIVER_FINDFIRST				ArchiverFindFirst;
	COMMON_ARCHIVER_FINDNEXT				ArchiverFindNext;
	COMMON_ARCHIVER_GETATTRIBUTE			ArchiverGetAttribute;
	COMMON_ARCHIVER_GETORIGINALSIZEEX		ArchiverGetOriginalSizeEx;
	COMMON_ARCHIVER_GETORIGINALSIZEEX		ArchiverGetCompressedSizeEx;
	COMMON_ARCHIVER_GETWRITETIME			ArchiverGetWriteTime;
	COMMON_ARCHIVER_GETWRITETIMEEX			ArchiverGetWriteTimeEx;
	COMMON_ARCHIVER_GETMETHOD				ArchiverGetMethod;

	virtual bool _ExamineArchive(LPCTSTR,CConfigManager&,bool &bInFolder,bool &bSafeArchive,const int,CString&,CString &strErr);
	virtual bool _ExamineArchiveFast(LPCTSTR,CConfigManager&,bool &bInFolder,CString&,CString &strErr);

	virtual bool ExtractSubDirectories(LPCTSTR lpszArcFile,CConfigManager&,const ARCHIVE_ENTRY_INFO_TREE* lpBase,const std::list<ARCHIVE_ENTRY_INFO_TREE*>&,LPCTSTR lpszOutputDir,bool bCollapseDir,CString &strLog);
	virtual bool ExtractDirectoryEntry(LPCTSTR lpszArcFile,CConfigManager&,const ARCHIVE_ENTRY_INFO_TREE* lpBase,const ARCHIVE_ENTRY_INFO_TREE* lpDir,LPCTSTR lpszOutputBaseDir,bool bCollapseDir,CString &strLog);

	//X|Xt@CɃf[^:MBCS,GXP[vKvƂȂ̌
	virtual void WriteResponceFile(HANDLE,LPCTSTR,bool bQuoteSpaces=true);
public:
	CArchiverDLL();
	virtual ~CArchiverDLL(){};
	virtual LOAD_RESULT LoadDLL(CConfigManager&,CString &strErr);
	virtual void FreeDLL();
	virtual WORD GetVersion()const;
	virtual WORD GetSubVersion()const;
	virtual bool IsUnicodeCapable()const{return false;}	//UNICODEΉDLLȂtrueԂ
	virtual bool IsWeakCheckArchive()const{return false;}	//CheckArchive̋@\n(UNBEL/AISĤ悤)Ȃtrue
	virtual bool IsWeakErrorCheck()const{return false;}	//%Prefix%()̃G[`FbNÂ(XacRett̂悤)Ȃtrue;𓀌ɍ폜邩̔fɎgp
	virtual BOOL CheckArchive(LPCTSTR);
	virtual ARCRESULT TestArchive(LPCTSTR,CString&);	//A[JCuǂ`FbN
	virtual bool Compress(LPCTSTR ArcFileName,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int Options,LPCTSTR lpszFormat,LPCTSTR lpszMethod,LPCTSTR lpszLevel,CString &strLog)=0;
	virtual bool Extract(LPCTSTR ArcFileName,CConfigManager&,const CConfigExtract&,bool bSafeArchive,LPCTSTR OutputDir,CString &)=0;
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false)=0;	//w肵t@Ĉ݉
	virtual bool QueryExtractSpecifiedOnlySupported(LPCTSTR)const{return true;}		//ExtractSpecifiedOnlyT|[gĂ邩ǂ
	virtual bool GetVersionString(CString&)const;
	virtual LPCTSTR GetName()const{return m_strDllName;}	//DLLԂ
	virtual int GetFileCount(LPCTSTR);	//A[JCũt@CԂ

	//A[JCuw肵t@C폜
	virtual bool DeleteItemFromArchive(LPCTSTR ArcFileName,CConfigManager&,const std::list<CString>&,CString &){return false;}
	virtual bool QueryDeleteItemFromArchiveSupported(LPCTSTR ArcFileName)const{return false;}		//DeleteFileT|[gĂ邩ǂ

	//A[JCuɎw肵t@Cǉ
	virtual bool AddItemToArchive(LPCTSTR ArcFileName,const std::list<CString>&,CConfigManager&,LPCTSTR lpDestDir,CString&){return false;}
	virtual bool QueryAddItemToArchiveSupported(LPCTSTR ArcFileName)const{return false;}

	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool bSkipDir,bool &bInFolder,bool &bSafeArchive,CString&,CString &strErr)=0;
		//A[JCuꂽt@CɃtH_ɓĂ邩ǂA
		//ăA[JCuSǂ𒲍
		//bSkipDir͓dtH_肪svȏꍇtrueɂȂB̂ƂA_ExamineArchiveFast͌ĂтȂȂčς

	virtual bool IsOK()const{return NULL!=m_hInstDLL;}		//A[JCoDLL[hĂ邩

	virtual bool ExtractItems(LPCTSTR lpszArcFile,CConfigManager&,const ARCHIVE_ENTRY_INFO_TREE* lpBase,const std::list<ARCHIVE_ENTRY_INFO_TREE*>&,LPCTSTR lpszOutputBaseDir,bool bCollapseDir,CString &strLog);

	//----------------------
	// ɓp\bh
	//----------------------
	virtual bool QueryInspectSupported()const{return true;}		//ɓT|[gĂ邩ǂ
	virtual bool InspectArchiveBegin(LPCTSTR,CConfigManager&);				//ɓJn
	virtual bool InspectArchiveEnd();						//ɓI
	virtual bool InspectArchiveGetFileName(CString&);		//ɓt@C擾
	virtual bool InspectArchiveNext();						//ɓ̃t@Cɐi߂
	virtual int  InspectArchiveGetAttribute();				//ɓt@C擾
	virtual bool InspectArchiveGetOriginalFileSize(LARGE_INTEGER&);	//ɓkOt@CTCY擾
	virtual bool InspectArchiveGetCompressedFileSize(LARGE_INTEGER&);	//ɓkt@CTCY擾
	virtual bool InspectArchiveGetWriteTime(FILETIME&);		//ɓt@CXV擾
	virtual DWORD InspectArchiveGetCRC();					//ɓt@CCRC擾
	virtual WORD InspectArchiveGetRatio();					//ɓt@Ck擾
	virtual bool InspectArchiveGetMethodString(CString&);	//ɓt@Ci[[h擾
};


/*
  Compress()Ăяoł́A
1.JgfBNg̐ݒ
2.X|Xt@Cւ̏(o͐t@C̐ݒ܂)
3.X|Xt@C̍폜
  ͌Ăяo̐ӔCŎsB

  DLLƂ̃XCb`̐ݒ̈ႢCompress()zB

*/
