/*
 * Copyright (c) 2005-2012, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#include "stdafx.h"
#include "Dlg_7z.h"

//=================
// 7Zʐݒ
//=================
LRESULT CConfigDlg7Z::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//----------------
	// k`̑I
	//----------------
	//vZbgg
	Check_UsePreset=GetDlgItem(IDC_CHECK_7Z_USE_PRESET);
	Check_UsePreset.SetCheck(m_Config.UsePreset);
	//蓮ݒ肷邩
	Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA]=GetDlgItem(IDC_RADIO_7Z_METHOD_LZMA);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD]=GetDlgItem(IDC_RADIO_7Z_METHOD_PPMD);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_BZIP2]=GetDlgItem(IDC_RADIO_7Z_METHOD_BZIP2);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_DEFLATE]=GetDlgItem(IDC_RADIO_7Z_METHOD_DEFLATE);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_COPY]=GetDlgItem(IDC_RADIO_7Z_METHOD_COPY);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA2]=GetDlgItem(IDC_RADIO_7Z_METHOD_LZMA2);

	Radio_CompressType[m_Config.CompressType].SetCheck(1);

	//vZbggꍇɂ͖
	for(int Type=0;Type<COUNTOF(Radio_CompressType);Type++){
		Radio_CompressType[Type].EnableWindow(!m_Config.UsePreset);
	}

	//------------------------------
	// kx̑I(vZbg)
	//------------------------------
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL0]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_0);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL1]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_1);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL5]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_5);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL7]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_7);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL9]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_9);

	Radio_CompressLevel[m_Config.CompressLevel].SetCheck(1);
	//vZbggȂꍇɂ͖
	for(int Type=0;Type<COUNTOF(Radio_CompressLevel);Type++){
		Radio_CompressLevel[Type].EnableWindow(m_Config.UsePreset);
	}

	//----------------------
	// LZMAk[h̑I
	//----------------------
	Radio_LZMA_Mode[SEVEN_ZIP_LZMA_MODE0]=GetDlgItem(IDC_RADIO_7Z_LZMA_MODE0);
	Radio_LZMA_Mode[SEVEN_ZIP_LZMA_MODE1]=GetDlgItem(IDC_RADIO_7Z_LZMA_MODE1);

	Radio_LZMA_Mode[m_Config.LZMA_Mode].SetCheck(1);
	//vZbggꍇɂ͖
	for(int Type=0;Type<COUNTOF(Radio_LZMA_Mode);Type++){
		Radio_LZMA_Mode[Type].EnableWindow((SEVEN_ZIP_COMPRESS_LZMA==m_Config.CompressType || SEVEN_ZIP_COMPRESS_LZMA2==m_Config.CompressType)&&(!m_Config.UsePreset));
	}

	//------------
	// wb_k
	//------------
	Check_HeaderCompression=GetDlgItem(IDC_CHECK_7Z_HEADER_COMPRESSION);

	//------------
	// PPMd̐ݒ
	//------------
	//fTCY
	::SendMessage(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),EM_LIMITTEXT,2,NULL);
	Check_SpecifyPPMdModelSize=GetDlgItem(IDC_CHECK_7Z_SPECIFY_PPMD_MODEL_SIZE);
	Check_SpecifyPPMdModelSize.SetCheck(m_Config.SpecifyPPMdModelSize);
	//vZbggꍇɂ͖
	Check_SpecifyPPMdModelSize.EnableWindow((SEVEN_ZIP_COMPRESS_PPMD==m_Config.CompressType)&&!m_Config.UsePreset);
	::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),(SEVEN_ZIP_COMPRESS_PPMD==m_Config.CompressType)&&m_Config.SpecifyPPMdModelSize&&!m_Config.UsePreset);

	//DDXAbvf[g
	DoDataExchange(FALSE);

	//wb_Sk̐ݒ
	::EnableWindow(GetDlgItem(IDC_CHECK_7Z_FULL_HEADER_COMPRESSION),Check_HeaderCompression.GetCheck());

	return TRUE;
}

LRESULT CConfigDlg7Z::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//----------------
	// k`̑I
	//----------------
	//vZbggǂ
	m_Config.UsePreset=Check_UsePreset.GetCheck();

	//蓮ݒ̏ꍇ
	for(int Type=0;Type<COUNTOF(Radio_CompressType);Type++){
		if(Radio_CompressType[Type].GetCheck()){
			m_Config.CompressType=(SEVEN_ZIP_COMPRESS_TYPE)Type;
			break;
		}
	}

	//------------------
	// kx̑I
	//------------------
	for(int Type=0;Type<COUNTOF(Radio_CompressLevel);Type++){
		if(Radio_CompressLevel[Type].GetCheck()){
			m_Config.CompressLevel=(SEVEN_ZIP_COMPRESS_LEVEL)Type;
			break;
		}
	}

	//----------------------
	// LZMAk[h̑I
	//----------------------
	for(int Type=0;Type<COUNTOF(Radio_LZMA_Mode);Type++){
		if(Radio_LZMA_Mode[Type].GetCheck()){
			m_Config.LZMA_Mode=(SEVEN_ZIP_LZMA_MODE)Type;
			break;
		}
	}

	//---------------
	// DDXf[^XV
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}
	//---------------
	// PPMd̐ݒ
	//---------------
	//fTCY
	m_Config.SpecifyPPMdModelSize=Check_SpecifyPPMdModelSize.GetCheck();
//	m_Config.PPMdModelSize=PPMdModelSize;
	return TRUE;
}

LRESULT CConfigDlg7Z::OnUsePreset(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		for(int Type=0;Type<COUNTOF(Radio_CompressType);Type++){
			Radio_CompressType[Type].EnableWindow(!Check_UsePreset.GetCheck());
		}
		for(int Type=0;Type<COUNTOF(Radio_CompressLevel);Type++){
			Radio_CompressLevel[Type].EnableWindow(Check_UsePreset.GetCheck());
		}
		for(int Type=0;Type<COUNTOF(Radio_LZMA_Mode);Type++){
			BOOL bCheck=Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA].GetCheck() || Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA2].GetCheck();
			Radio_LZMA_Mode[Type].EnableWindow(bCheck&&!Check_UsePreset.GetCheck());
		}
		Check_SpecifyPPMdModelSize.EnableWindow(Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&!Check_UsePreset.GetCheck());
		::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&Check_SpecifyPPMdModelSize.GetCheck()&&!Check_UsePreset.GetCheck());
	}
	return 0;
}

LRESULT CConfigDlg7Z::OnSpecifyPPMdModelSize(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),(Check_SpecifyPPMdModelSize.GetCheck())&&(!Check_UsePreset.GetCheck()));
	}
	return 0;
}

LRESULT CConfigDlg7Z::OnSelectCompressType(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		//LZMA
		for(int Type=0;Type<COUNTOF(Radio_LZMA_Mode);Type++){
			BOOL bCheck=Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA].GetCheck() || Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA2].GetCheck();
			Radio_LZMA_Mode[Type].EnableWindow(bCheck&&!Check_UsePreset.GetCheck());
		}
		//PPMd
		Check_SpecifyPPMdModelSize.EnableWindow(Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&!Check_UsePreset.GetCheck());
		::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&Check_SpecifyPPMdModelSize.GetCheck()&&!Check_UsePreset.GetCheck());
	}
	return 0;
}

LRESULT CConfigDlg7Z::OnHeaderCompression(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		::EnableWindow(GetDlgItem(IDC_CHECK_7Z_FULL_HEADER_COMPRESSION),Check_HeaderCompression.GetCheck());
	}
	return 0;
}

