/*
 * Copyright (c) 2005-2012, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#pragma once

bool UtilGetTemporaryFileName(LPTSTR fname,LPCTSTR prefix);
bool UtilGetTemporaryFileNameA(LPSTR fname,LPCSTR prefix);
bool UtilDeletePath(LPCTSTR PathName);
bool UtilDeleteDir(LPCTSTR Path,bool);
int UtilAppendFile(HANDLE hWriteTo,HANDLE hReadFrom);
void UtilModifyPath(CString&);	//DTVN\̂pXC

BOOL UtilMoveFileToRecycleBin(LPCTSTR);	//t@CݔɈړ
BOOL UtilMoveFileToRecycleBin(const std::list<CString>&);	//t@CݔɈړ

//tH_t@C(fBNg͏)ċA
bool UtilRecursiveEnumFile(LPCTSTR lpszRoot,std::list<CString>&);

//tpX΃pX̎擾
enum PATHERROR{
	PATHERROR_NONE,		//
	PATHERROR_INVALID,	//p[^w肪s
	PATHERROR_ABSPATH,	//΃pX̎擾Ɏs
	PATHERROR_NOTFOUND,	//t@C̓tH_Ȃ
	PATHERROR_LONGNAME,	//Ot@C擾s
};
PATHERROR UtilGetCompletePathName(CString &_FullPath,LPCTSTR lpszFileName);
//΃pX̎擾
bool UtilGetAbsPathName(CString &_FullPath,LPCTSTR lpszFileName);

//ChJ[h̓WJ
bool UtilPathExpandWild(std::list<CString> &r_outList,const std::list<CString> &r_inList);
bool UtilPathExpandWild(std::list<CString> &r_outList,const CString &r_inParam);

//pX̃fBNgo
void UtilPathGetDirectoryPart(CString&);

//̃vÕt@CԂ
LPCTSTR UtilGetModulePath();

//̃vÔĂfBNg̃pXԂ
LPCTSTR UtilGetModuleDirectoryPath();

//Kw̃fBNgCɍ쐬
BOOL UtilMakeSureDirectoryPathExists(LPCTSTR lpszPath);

//TCHARt@CSJISt@CɕϊBϊłȂꍇɂ́AfalseԂ
bool UtilPathT2A(CStringA&,LPCTSTR,bool bOnDisk);

//pXɋʂ镔oApXo
void UtilGetBaseDirectory(CString &BasePath,const std::list<CString> &PathList);

//t@CɎgȂu
void UtilFixFileName(CString &,LPCTSTR lpszOrg,TCHAR replace);

LPCTSTR UtilPathNextSeparator(LPCTSTR lpStr);
bool UtilPathNextSection(LPCTSTR lpStart,LPCTSTR& r_lpStart,LPCTSTR& r_lpEnd,bool bSkipMeaningless);
//Path'/''\\'ŏIĂȂtrue
bool UtilPathEndWithSeparator(LPCTSTR lpPath);
void UtilPathGetLastSection(CString &strSection,LPCTSTR lpPath);

//t@CۂƁA͎w肳ꂽƂ܂œǂݍ(-1Ŋۂ)
bool UtilReadFile(LPCTSTR lpFile,std::vector<BYTE> &cReadBuffer,DWORD dwLimit=-1);

struct FILELINECONTAINER{
	virtual ~FILELINECONTAINER(){}
	std::vector<WCHAR> data;
	std::vector<LPCWSTR> lines;
};
bool UtilReadFileSplitted(LPCTSTR lpFile,FILELINECONTAINER&);
